#ifndef ROBO_XENO_RTIO_PHIDGETS_DEVICE_H_
#define ROBO_XENO_RTIO_PHIDGETS_DEVICE_H_

//#include <phidget21.h>

#include "HandleCreator.h"
#include "PhidgetError.h"
namespace rtio {

namespace phidgets {

	template <class Handle,class Creator=HandleCreator<Handle> >
	class Device {
	public :
		enum Timeout {
			BLOCKING = 0
		};
		Device(int serialNumber = -1,
		       unsigned int timeout = BLOCKING) {
			Creator c;
			c(&d_handle);
			CPhidget_open((CPhidgetHandle)d_handle,serialNumber);
			int res = CPhidget_waitForAttachment((CPhidgetHandle)d_handle,timeout);
			if(res){
				CPhidget_delete((CPhidgetHandle)d_handle);
				throw PhidgetError("Error while waiting attachment",res);
			}

			//now open and ready
		}

		virtual ~Device() {
			CPhidget_close( (CPhidgetHandle)d_handle);
			CPhidget_delete((CPhidgetHandle)d_handle);
		}

		Handle & GetHandle(){ return d_handle; }
		const Handle & GetHandle() const { return d_handle; }

	private :
		Handle d_handle;
	};



} //namespace phidgets

} //namespace rtio





#endif //ROBO_XENO_RTIO_PHIDGETS_DEVICE_H_
