/**
 * \file Event.h
 *
 *  \date Dec 20, 2012
 *  \author Alexandre Tuleu
 */

#ifndef ROBO_XENO_EVENT_H_
#define ROBO_XENO_EVENT_H_

#include <pthread.h>

/**
 *
 */
namespace rtio {

namespace phidgets {

/**
 *
 */
class Event {
public:
	typedef long Timeout;
	const static Timeout NON_BLOCKING = -1;
	const static Timeout INFINITE     = 0;

	typedef unsigned long long Mask;

	enum Mode {
		ANY_FLAGS,
		ALL_FLAGS
	};

	Event(Mask iValue = 0);
	~Event();


	bool Wait(Mask flags,Mask * rMask,Mode m,Timeout t);

	Mask Signal(Mask flags);

	Mask Clear(Mask flags);

	void Lock();

	void Unlock();

private :

	void NotifiyChanges();

	void WaitUponChanges();

	pthread_mutex_t d_mutex;
	pthread_cond_t  d_condition;
	Mask            d_mask;
};

} /* namespace phidgets */

} /* namespace rtio */
#endif // ROBO_XENO_EVENT_H_
