/**
 * \file PhidgetError.cpp
 *
 *  \date Dec 20, 2012
 *  \author Alexandre Tuleu
 */

#include "PhidgetError.h"
#include <phidget21.h>
#include <sstream>

namespace rtio {

namespace phidgets {

	PhidgetError::PhidgetError(const std::string & str , int err)
	: std::runtime_error("Unitilaized Phidget error"){
		std::ostringstream os;
		const char * errStr;
		CPhidget_getErrorDescription(err,&errStr);
		os << str << " : " << errStr;
		d_what = os.str();
	}

	PhidgetError::~PhidgetError() throw(){
	}

	const char * PhidgetError::what() const throw(){
		return d_what.c_str();
	}

} /* namespace phidgets */

} /* namespace rtio */
