/**
 * \file Bridge.h
 *
 *  \date Dec 20, 2012
 *  \author Alexandre Tuleu
 */

#ifndef ROBO_XENO_BRIDGE_H_
#define ROBO_XENO_BRIDGE_H_


#include "../Device.h"
#include "../Event.h"
#include <native/event.h>

#include <vector>
/**
 *
 */
namespace rtio {

namespace phidgets {

/**
 *
 */
class Bridge : public Device<CPhidgetBridgeHandle>{
public:
	Bridge(int serialNumber, unsigned int timeout);
	virtual ~Bridge();

	int MaxInput();
	int MinDataRate();
	int MaxDataRate();

	static CPhidgetBridge_Gain GainFromInt(unsigned int gain);

	void SetDataRate(unsigned int millisecond);

	void EnableInput(int input,CPhidgetBridge_Gain gain);

	void StartFullRefresh();

	void WaitForFullRefresh();

	double Data(unsigned int i) const;

private :
	static int DataHandler(CPhidgetBridgeHandle b, void * itself,int input,double value);

	Event d_event;
	Event::Mask d_mask;

	int d_maxInput;
	int d_minDataRate;
	int d_maxDataRate;
	std::vector<double> d_data1,d_data2;
	std::vector<double> * d_dataRdPtr;
	std::vector<double> * d_dataWrPtr;

};

} /* namespace phidgets */

} /* namespace rtio */
#endif // ROBO_XENO_BRIDGE_H_
