/*
 * BridgeQueue.h
 *
 *  Created on: Dec 20, 2012
 *      Author: tuleu
 */

#ifndef BRIDGEQUEUE_H_
#define BRIDGEQUEUE_H_

#include <robo-xeno/rtio/Queue.h>

#include "Config.h"
#include "Bridge.h"

#include <set>

#include <tr1/memory>

namespace rtio {

namespace phidgets {

typedef std::tr1::shared_ptr<Bridge> BridgePtr;

class BridgeInput : public rtio::Input {
public :
	BridgeInput(const BridgePtr & bridge, unsigned int input);
	virtual ~BridgeInput();

	virtual void Read();
private :
	BridgePtr    d_bridge;
	unsigned int d_input;
};

class BridgeQueue : public rtio::Queue {
public:
	BridgeQueue(rtio::Manager & manager,
                rtio::Queue::ID id,
                int priority,
                rtio::Queue::Mode m);
	virtual ~BridgeQueue();

	void LoadFromConfig(BridgesSection & bridgesConfig);

	void PreSend();
	void PreRead();
	void PostRead();
private :

	typedef std::set<BridgePtr>          SetOfBridges;


	void AddBridgeDevice(std::tr1::shared_ptr<BridgeSection> bridgeConfig);

	void AddBridgeInput(const std::string & name,
	                    std::tr1::shared_ptr<BridgeInputSection> bridgeInputConfig,
	                    BridgePtr bridge);

	SetOfBridges d_devices;
};

} /* namespace phidgets */

} /* namespace rtio */
#endif /* BRIDGEQUEUE_H_ */
