#ifndef ROBO_XENO_RTIO_PHIDGETS_BRIDGE_CONFIG_H_
#define ROBO_XENO_RTIO_PHIDGETS_BRIDGE_CONFIG_H_

#include <biorob-cpp/options/Config.h>


namespace rtio{

namespace phidgets{

	class BridgeInputSection : public options::ConfigSection {
	public :
		BridgeInputSection(options::Section::Ptr s);
		virtual ~BridgeInputSection();

		BCPP_ADD_OPTION(Input,"input",int,-1,"Input of the phidget bridge to be read")
		BCPP_ADD_OPTION(Gain,"gain",unsigned int,1,"Gain of the input, should be in [1 8 16 32 64 128")
	};


	class BridgeSection : public options::DynamicConfigSection<BridgeInputSection> {
	public :
		BridgeSection(options::Section::Ptr s);
		virtual ~BridgeSection();

		BCPP_ADD_OPTION(SerialNumber,"serial-number",int,-1,"Serial number of the phidget, -1 for any")
		BCPP_ADD_OPTION(DataRate,"data-rate",int,10,"Data rate of the phidget in ms")
	};


	class BridgesSection : public options::DynamicConfigSection<BridgeSection> {
	public :
		BridgesSection(options::Section::Ptr s);
		virtual ~BridgesSection();
	};

} //namespace phidgets

} //namespace rtio




#endif
