/**
 * \file ServoQueue.h
 *
 *  \date Dec 14, 2012
 *  \author Alexandre Tuleu
 */

#ifndef ROBO_XENO_RTIO_RBIO_SERVOQUEUE_H_
#define ROBO_XENO_RTIO_RBIO_SERVOQUEUE_H_

#include <robo-xeno/rtio/Queue.h>
#include <biorob-rbio/servo/Servo.h>

#include <native/types.h>
/**
 *
 */
namespace rtio {
/**
 *
 */
class ServoQueue : public rtio::Queue{
public:
	class Output : public rtio::Output {
	public :
		Output(Servo::Ptr servo);
		virtual ~Output();
		virtual void Send();
	private :
		Servo::Ptr d_servo;
	};
	ServoQueue(rtio::Manager& manager,
	           rtio::Queue::ID id,
	           int priority,
	           rtio::Queue::Mode m);
	virtual ~ServoQueue();

	void SetUpdatePeriod(double second);

	virtual void PreSend();
	virtual void PreRead();
	virtual void PostRead();

private :
	RTIME  d_start;
	RTIME d_updatePeriod;
};
}//namespace rbio
#endif // ROBO_XENO_RTIO_RBIO_SERVOQUEUE_H_
