/**
 * \file CdnConfig.cpp
 *
 *  \date Dec 10, 2012
 *  \author Alexandre Tuleu
 */

#include "CdnConfig.h"
#include <stdexcept>

#include <biorob-cpp/log/Logger.h>

namespace rx {

	CdnConfig::CdnConfig()
		: options::Config("robo-xeno-cdn")
		, d_shMain(Section())
		, d_shCdn(Section())
		, d_shCpg(Section()){
	}

	CdnConfig::~CdnConfig(){
	}



	CdnSection::CdnSection(options::Section::Ptr s)
		: options::ConfigSection(s)
		, d_hFile(Section())
		, d_overrides(Section().AddSubSection("override", "overriding rules for codyn")){
	}

	CdnSection::~CdnSection(){
	}

	const options::Section& rx::CdnSection::Overrides() const{
		return *d_overrides;
	}


} /* namespace rx */
