/**
 * \file CdnConfig.h
 *
 *  \date Dec 10, 2012
 *  \author Alexandre Tuleu
 */

#ifndef ROBO_XENO_CDN_CDNCONFIG_H_
#define ROBO_XENO_CDN_CDNCONFIG_H_

#include <robo-xeno/main/MainConfigSection.h>

/**
 *
 */
namespace rx {

/**
 *
 */
class CdnSection : public options::ConfigSection {
public :
	CdnSection(options::Section::Ptr s);
	virtual ~CdnSection();

	BCPP_ADD_OPTION(File,"network-file",std::string,"","File to use")
	const options::Section & Overrides() const;
private :
	options::Section::Ptr d_overrides;
};

class CdnConfig : public options::Config{
public:
	CdnConfig();
	virtual ~CdnConfig();

	BCPP_ADD_SUBSECTION(MainConfigSection,Main,"main", "main section");
	BCPP_ADD_SUBSECTION(CdnSection,Cdn,"cdn","cdn section");
	BCPP_ADD_SUBSECTION(CdnSection,Cpg,"cpg","DEPRECIATED cpg section");

};

}
#endif // ROBO_XENO_CDNCONFIG_H_
