/**
 * \file CdnProcess.h
 *
 *  \date Dec 10, 2012
 *  \author Alexandre Tuleu
 */

#ifndef ROBO_XENO_CDN_CDNPROCESS_H_
#define ROBO_XENO_CDN_CDNPROCESS_H_

#include <robo-xeno/process/Process.h>
#include "CdnConfig.h"

#include <codyn/cdn-network.h>
/**
 *
 */
namespace rx {
/**
 *
 */
class CdnProcess : public rx::Process{
public:
	CdnProcess(const CdnSection & config);
	virtual ~CdnProcess();

	virtual void Step(double ts);

	rx::Input::Ptr  GetInput(const std::string & name);
	rx::Output::Ptr  GetOutput(const std::string & name);
private :
	typedef std::tr1::shared_ptr<CdnNetwork> CdnNetworkPtr;
	class Input : public rx::Input {
	public :
		Input(CdnVariable * var);
		virtual ~Input();

		void SendToProcess(double value);
	private :
		CdnVariable * d_variable;
	};

	class Output : public rx::Output {
	public :
		Output(CdnVariable * var);
		virtual ~Output();

		double ReadFromProcess();
	private :
		CdnVariable * d_variable;
	};
	void InitIO();
	void InitOverride(const options::Section & overrides);

	void  FindFromSerialized(const std::string & serialized,
	                         bool & isGlobal,
	                         CdnVariable ** variable);

	CdnNetworkPtr d_network;
};

}
#endif // ROBO_XENO_CDNPROCESS_H_
