/**
 * \file main.cpp
 *
 *  \date Dec 10, 2012
 *  \author Alexandre Tuleu
 */

#include <robo-xeno/main/Main.cpp>
#include "CdnProcess.h"

#include <biorob-cpp/log/Logger.h>

bool UseCpgSection(const rx::CdnConfig & config){
	//there is some override in the cpg section, it should not
	if(config.Cpg().Overrides().Options().size()){
		return true;
	}

	return !config.Cpg().File().empty();
}

int main(int argc, char ** argv){
	rx::Main main(argc,argv);
	rx::CdnConfig config;

	main.ProcessOptions<rx::CdnConfig>(config);

	config.AppendFile(main.AdditionnalConfigFile());

	config.LoadAllFiles();

	rx::Process::Ptr p;

	if(UseCpgSection(config)){
		std::cerr << "Warning : you use a depreciated version of config file. Please replace 'cpg' by 'cdn'.";
		std::cerr << "Just to annoy you, I wait 5 seconds :P :P :P :P :P." << std::endl;
		sleep(5);
		p = rx::Process::Ptr(new rx::CdnProcess(config.Cpg()));
	} else {
		p = rx::Process::Ptr(new rx::CdnProcess(config.Cdn()));
	}

	return main.Exec<rx::CdnConfig>(config,p);
}



