/**
 * \file NativeError.cpp
 *
 *  \date Dec 13, 2012
 *  \author Alexandre Tuleu
 */

#include "NativeError.h"
#include <sstream>
#include <cstring>

namespace rx {

	NativeError::NativeError(const std::string & whatStr,int error){
		std::ostringstream os;
		os << whatStr << " ("  << error << ") : " << strerror(error);
		d_what = os.str();
	}

	NativeError::~NativeError() throw(){
	}

	const char * NativeError::what() const throw(){
		return d_what.c_str();
	}

} /* namespace rx */
