/**
 * \file MainConfigSection.cpp
 *
 *  \date Dec 7, 2012
 *  \author Alexandre Tuleu
 */

#include "MainConfigSection.h"

namespace rx {

//	ProcessConfigSection::ProcessConfigSection(options::Section::Ptr s)
//		: options::ConfigSection<ProcessConfigSection>(s){
//
//	}
//
//	ProcessConfigSection::~ProcessConfigSection(){
//		// TODO Auto-generated destructor stub
//	}



MappingSection::MappingSection(options::Section::Ptr s)
	: options::ConfigSection(s){
}

MappingSection::~MappingSection(){
}

void MappingSection::Map(ProcessIOByRTIO & result) const{
	result.clear();
	const options::Section::ListOfOptions & options = Section().Options();

	for(options::Section::ListOfOptions::const_iterator o = options.begin();
	    o != options.end();
	    ++o){
		result[o->first] = o->second->ValueAsString();
	}
}

MappingConfigSection::MappingConfigSection(options::Section::Ptr s)
	: options::ConfigSection(s)
	, d_shOut(Section())
	, d_shIn(Section()){
}

MappingConfigSection::~MappingConfigSection(){
}


MainConfigSection::MainConfigSection(options::Section::Ptr s)
	: options::ConfigSection (s)
	, d_hTimestep(*s)
	, d_hPriority(Section())
	, d_hIterationPerStep(Section())
	, d_hCliFeedbackIteration(Section())
	, d_hIOLog(Section())
	, d_hQueueSynchronizationLog(Section())
	, d_shMapping(Section())
	, d_shModules(Section()){
}

MainConfigSection::~MainConfigSection(){
}
} /* namespace rx */
