/**
 * \file MockModuleUTest.cpp
 *
 *  \date Dec 7, 2012
 *  \author Alexandre Tuleu
 */



#include <robo-xeno/rtio/MockModule.h>

#include <gmock/gmock.h>

//normally you would use :
//using namespace rtio;
//BIOROB_CPP_EXPORT_PLUGIN(Module,MockMocule)


C_EXPORT rtio::Module * BIOROB_CPP_ENTRY_FUNCTION_NAME(Module) ();
C_EXPORT void BIOROB_CPP_EXIT_FUNCTION_NAME(Module) (rtio::Module * m);

//this method needs redefinition
C_EXPORT rtio::Module * BIOROB_CPP_ENTRY_FUNCTION_NAME(Module) (){
	//return the last created instance, not a new one, this is a trick for
	//being able to set the expectation with gmock
	return rtio::MockModule::LastCreated();
}

//exactly the same definition ...
C_EXPORT void BIOROB_CPP_EXIT_FUNCTION_NAME(Module) (rtio::Module * m){
	delete m;
}
