/**
 * \file ModuleLoader.h
 *
 *  \date Dec 6, 2012
 *  \author Alexandre Tuleu
 */

#ifndef ROBO_XENO_RX_MODULELOADER_H_
#define ROBO_XENO_RX_MODULELOADER_H_

#include "ModulesSection.h"

#include <robo-xeno/rtio/Module.h>

/**
 *
 */
namespace rx {
/**
 *
 */
class ModuleLoader {
public:
	ModuleLoader();
	virtual ~ModuleLoader();


	void LoadModuleFromConfig(const ModulesSection & modules);

	void StartQueuesOfModules(rtio::Manager & manager);


private :
	typedef std::vector<std::string> ListOfModuleName;
	typedef PluginLoader<rtio::Module>::PluginPtr ModulePtr;
	typedef std::map<std::string,ModulePtr > ModuleByName;

	void SplitNames(std::string allNames, ListOfModuleName & moduleNames);
	void LoadModuleList(const ListOfModuleName & modules);

	ModuleByName d_modules;
};

} /* namespace rx */
#endif // ROBO_XENO_RX_MODULELOADER_H_
