/**
 * \file ModuleLoaderUTest.h
 *
 *  \date Dec 7, 2012
 *  \author Alexandre Tuleu
 */

#ifndef ROBO_XENO_MODULELOADERUTEST_H_
#define ROBO_XENO_MODULELOADERUTEST_H_

#include <gtest/gtest.h>

#include "ModulesSection.h"
#include <robo-xeno/module/ModuleLoaderConfigUTest.h>

namespace rtio{
	class Manager;
}

/**
 *
 */
namespace rx {
/**
 *
 */
class ModuleLoaderUTest : public ::testing::Test{
public :
	static void MockInitIO(rtio::Manager & manager);
protected :
	void SetUp();
	void TearDown();

	ModulesSection & Config();

	void AddModule(options::Option<std::string>::Ptr o, const std::string & name);



private :
	ModulesSection * d_section;
};

} //namespace rx
#endif // ROBO_XENO_MODULELOADERUTEST_H_
