/**
 * \file Process.cpp
 *
 *  \date Dec 7, 2012
 *  \author Alexandre Tuleu
 */

#include "Process.h"

#include <stdexcept>
#include <sstream>
#include <fcntl.h>
#include <string.h>

namespace rx {

	Process::Process()
		: d_inputBuffer()
		, d_controlInputs(){
		d_inputBuffer.reserve(100);
//		rt_mutex_create(&d_mutex,NULL);
	}

	Process::~Process(){
//		rt_mutex_delete(&d_mutex);
	}


	void Process::BufferedWrite(ControlInput & i){
//		rt_mutex_acquire(&d_mutex,TM_INFINITE);
		d_inputBuffer.push_back(i);
//		rt_mutex_release(&d_mutex);
	}

	void Process::Flush(){
//		int res = rt_mutex_acquire(&d_mutex,TM_NONBLOCK);
//		if(res == -ETIMEDOUT){
//			return;
//		} else if(res != 0) {
//			std::ostringstream os;
//			os << "Error whikle acquiring mutex : " << strerror(-res);
//			throw std::runtime_error(os.str());
//		}
		//rt mutex acquired and working
		for(InputBuffer::iterator ci = d_inputBuffer.begin();
		    ci != d_inputBuffer.end();
		    ++ci){
			ci->input->SendToProcess(ci->value);
		}
		d_inputBuffer.clear();
//		rt_mutex_release(&d_mutex);
	}


	void Process::AddControlInput(const std::string & name,
	                              const Input::Ptr & i,
	                              double initialValue){
		ControlInput ci;
		ci.value = initialValue;
		ci.input = i;
		d_controlInputs.insert(std::make_pair(name,ci));
	}

	Process::ControlInputByName & Process::ControlInputs(){
		return d_controlInputs;
	}

} /* namespace rx */
