/**
 * \file ProcessUtest.cpp
 *
 *  \date Dec 7, 2012
 *  \author Alexandre Tuleu
 */

#include "ProcessUTest.h"

namespace rx {

MockInput::~MockInput(){}

MockOutput::~MockOutput(){}

MockProcess::MockProcess()
	: d_input(new MockInput())
	, d_output(new MockOutput()){
	AddControlInput("in",std::tr1::static_pointer_cast<Input,MockInput>(d_input),3.90);
	ON_CALL(*this,GetInput(::testing::_)).WillByDefault(::testing::Return(Input::Ptr()));
	ON_CALL(*this,GetOutput(::testing::_)).WillByDefault(::testing::Return(Output::Ptr()));
}

MockProcess::~MockProcess(){}

const MockInput::Ptr& MockProcess::MyInput(){
	return d_input;
}

const MockOutput::Ptr& MockProcess::MyOutput(){
	return d_output;
}

void ProcessUTest::SetUp(){
}

void ProcessUTest::TearDown(){
}

TEST_F(ProcessUTest,BufferedWrite){
	EXPECT_CALL(*(d_process.MyInput()),SendToProcess(42.0)).Times(1);

	Process::ControlInput & i = d_process.ControlInputs()["in"];
	i.value = 42.0;
	d_process.BufferedWrite(i);
	d_process.Flush();

	d_process.BufferedWrite(i);
	//will not be taken into account because no flush.
}



} /* namespace rx */
