/**
 * \file MockModule.h
 *
 *  \date Dec 7, 2012
 *  \author Alexandre Tuleu
 */

#ifndef ROBO_XENO_MOCKMODULE_H_
#define ROBO_XENO_MOCKMODULE_H_

#include <gmock/gmock.h>

#include "Module.h"
/**
 *
 */
namespace rtio {
/**
 *
 */
class MockModule : public Module{
public:
	MockModule();
	virtual ~MockModule();

	MOCK_METHOD1(InitIO,void(Manager & ));
	MOCK_METHOD0(Die,void());

	static void SetLastCreated(MockModule * m);
	static MockModule * LastCreated();

private :
	static MockModule * s_lastCreated;
};



} // namespace rtio
#endif // ROBO_XENO_MOCKMODULE_H_
