/**
 * \file MockQueue.cpp
 *
 *  \date Dec 4, 2012
 *  \author Alexandre Tuleu
 */

#include "MockQueue.h"

namespace rtio {

MockQueue::MockQueue(rtio::Manager & manager, ID id, int , Mode )
	: Queue(manager,id,70,Queue::NonRealtime){
	rt_sem_create(&d_semaphore,0,0,S_FIFO);
}

MockQueue::~MockQueue(){
	rt_sem_delete(&d_semaphore);
}

RT_SEM * MockQueue::Semaphore() {
	static RT_SEM * s(0);
	if(!s){
		s = new RT_SEM();
		rt_sem_create(s,0,0,S_FIFO);
	}
	return s;
}

RT_SEM * MockQueue::MySemaphore(){
	return &d_semaphore;
}

}
