/**
 * \file MockQueue.h
 *
 *  \date Dec 4, 2012
 *  \author Alexandre Tuleu
 */

#ifndef ROBO_XENO_MOCKQUEUE_H_
#define ROBO_XENO_MOCKQUEUE_H_

#include <gmock/gmock.h>

#include "Queue.h"
#include <native/sem.h>

namespace rtio{

class Manager;
/**
 *
 */
class MockQueue : public Queue{
public:
	typedef std::tr1::shared_ptr<MockQueue> Ptr;
	MockQueue(rtio::Manager & manager, ID id,
	          int priority = 0, Mode m = NonRealtime);
	virtual ~MockQueue();

	MOCK_METHOD0(PreSend,void());
	MOCK_METHOD0(PreRead,void());
	MOCK_METHOD0(PostRead,void());

	static RT_SEM * Semaphore();

	RT_SEM * MySemaphore();

private :
	RT_SEM d_semaphore;
};

}

ACTION_P(PostSemaphore,s) {
	rt_sem_v(s);
}

ACTION_P(WaitSemaphore,s) {
	rt_sem_p(s,TM_INFINITE);
}
#endif // ROBO_XENO_MOCKQUEUE_H_
