/*
 * event.h
 *
 *  Created on: 5 nov. 2012
 *      Author: akay
 */

#ifndef EVENT_H_
#define EVENT_H_

#include "types.h"
#include "mutex.h"
#ifdef __cplusplus
extern "C" {
#endif

typedef
struct robo_xeno_rt_event{
	robo_xeno_rt_event();
	pthread_mutex_t *  mutex;
	unsigned long   *  mask;
	char *       name;
} RT_EVENT;

enum EventFlagMode{
	EV_PRIO,
	EV_FIFO
};

enum EvenWaitMode {
	EV_ANY,
	EV_ALL
};

int rt_event_create (RT_EVENT *event, const char *name, unsigned long ivalue, int mode);

int rt_event_delete (RT_EVENT *event);

int rt_event_wait (RT_EVENT *event, unsigned long mask, unsigned long *mask_r, int mode, RTIME timeout);

int rt_event_clear (RT_EVENT *event, unsigned long mask, unsigned long *mask_r);

int rt_event_bind (RT_EVENT *event, const char *name, RTIME timeout);

int rt_event_signal (RT_EVENT *event, unsigned long mask);

#ifdef __cplusplus
}
#endif


#endif /* EVENT_H_ */
