/*
 * Copyright (c) 2012 Alexandre Tuleu
 *
 * This file is part of xeno-cpg.
 *
 *   xeno-cpg is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   xeno-cpg is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with PROJECT.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef XENO_CPG_XENOMAI_EMULATION_MUTEX_H_
#define XENO_CPG_XENOMAI_EMULATION_MUTEX_H_

#include <pthread.h>

#include "types.h"

#ifdef __cplusplus
extern "C" {
#endif


struct rt_mutex {
	pthread_mutex_t * mutex;
};
typedef struct rt_mutex RT_MUTEX;


int rt_mutex_create (RT_MUTEX *mutex, const char *name);

int rt_mutex_delete(RT_MUTEX * mutex);

int rt_mutex_acquire (RT_MUTEX *mutex, RTIME timeout);

int rt_mutex_release (RT_MUTEX *mutex);

int rt_mutex_bind (RT_MUTEX *mutex, const char *name, RTIME timeout);

int rt_mutex_unbind (RT_MUTEX *mutex);


#ifdef __cplusplus
}
#endif


#endif //ONCILLA_CPG_XENOMAI_EMU_MUTEX_H_
