/**
 * \file pipe.h
 *
 *  \date Dec 7, 2012
 *  \author Alexandre Tuleu
 */

#ifndef ROBO_XENO_PIPE_H_
#define ROBO_XENO_PIPE_H_


#define XENO_EMULATION_PIPE_PATH "/tmp/xeno-emulation-pipe-"

#include <stdio.h>
#include "types.h"
#include <unistd.h>

#ifdef __cplusplus
extern "C" {
#endif

#define P_MINOR_AUTO 0
#define P_URGENT 0
#define P_NORMAL 1

typedef struct rt_pipe {
	char * name;
	int    file;
} RT_PIPE;

int rt_pipe_create (RT_PIPE *pipe,
                    const char *name,
                    int minor,
                    size_t poolsize);

int rt_pipe_delete (RT_PIPE *pipe);

ssize_t rt_pipe_read (RT_PIPE *pipe, void *buf, size_t size, RTIME timeout);

ssize_t rt_pipe_write (RT_PIPE *pipe, const void *buf, size_t size, int mode);



#ifdef __cplusplus
}
#endif

#endif // ROBO_XENO_PIPE_H_
