/**
 * \file sem.h
 *
 *  \date Dec 5, 2012
 *  \author Alexandre Tuleu
 */

#ifndef ROBO_XENO_SEM_H_
#define ROBO_XENO_SEM_H_

#include "types.h"

#include <semaphore.h>

#ifdef __cplusplus
extern "C" {
#endif

typedef struct RT_SEM {
	sem_t * s;
	char  * name;
}RT_SEM;

typedef struct rt_sem_info{
	unsigned long count;
}RT_SEM_INFO;

enum {
	S_FIFO,
	S_PRIO,
	S_PULSE
};

int rt_sem_create (RT_SEM *sem, const char *name, unsigned long icount, int mode);


int rt_sem_delete (RT_SEM *sem);

int rt_sem_p (RT_SEM *sem, RTIME timeout);

int rt_sem_v (RT_SEM *sem);

int rt_sem_inquire(RT_SEM * sem, RT_SEM_INFO * info);
#ifdef __cplusplus
}
#endif

#endif // ROBO_XENO_SEM_H_
