/*
 * timer_linux.c
 *
 *  Created on: 5 nov. 2012
 *      Author: akay
 */


#include <xeno-emulation/config.h>


#ifndef ROBO_XENO_EMULATION_LINUX
#error "Only available for linux"
#endif



#include <xeno-emulation/timer.h>

#include <sys/timerfd.h>
#include <stdlib.h>
#include <unistd.h>

struct robo_xeno_timer {
	int timerfd;
};


robo_xeno_timer * create_robo_xeno_timer(){
	robo_xeno_timer * res = malloc(sizeof(struct robo_xeno_timer));
	res->timerfd = timerfd_create(CLOCK_MONOTONIC,0);
	return res;
}


int robo_xeno_timer_set_period(robo_xeno_timer *t, RTIME period){
	struct itimerspec spec,oldvalue;
	spec.it_value.tv_sec = 0;
	spec.it_value.tv_nsec = period;
	spec.it_interval.tv_sec = 0;
	spec.it_interval.tv_nsec = period;
	return timerfd_settime(t->timerfd,0,&spec,&oldvalue);
}

int robo_xeno_timer_wait_period(robo_xeno_timer * t, unsigned long * overruns_r){
	uint64_t o;
	if(read(t->timerfd,&o,sizeof(uint64_t)) == -1){
		return -errno;
	}
	if(overruns_r != NULL){
		*overruns_r = o;
	}
	return 0;
}

void free_robo_xeno_timer(robo_xeno_timer *t){
	close(t->timerfd);
	free(t);
}

